pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT > Class Template Reference
Module octree

Octree leaf node iterator class. More...

`#include <pcl/octree/octree_iterator.h>`

Inheritance diagram for pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT >:

## Public Member Functions

| OctreeLeafNodeBreadthFirstIterator (unsigned int max_depth_arg=0)
| Empty constructor. More...
| OctreeLeafNodeBreadthFirstIterator (OctreeT *octree_arg, unsigned int max_depth_arg=0)
| Constructor. More...
| OctreeLeafNodeBreadthFirstIterator (OctreeT *octree_arg, unsigned int max_depth_arg, IteratorState *current_state, const std::deque< IteratorState > &fifo=std::deque< IteratorState >())
| Copy constructor. More...
void | reset ()
| Reset the iterator to the first leaf in the breadth first way. More...
OctreeLeafNodeBreadthFirstIterator & | operator++ ()
| Preincrement operator. More...
OctreeLeafNodeBreadthFirstIterator | operator++ (int)
| Postincrement operator. More...
Public Member Functions inherited from pcl::octree::OctreeBreadthFirstIterator< OctreeT >
| OctreeBreadthFirstIterator (unsigned int max_depth_arg=0)
| Empty constructor. More...
| OctreeBreadthFirstIterator (OctreeT *octree_arg, unsigned int max_depth_arg=0)
| Constructor. More...
| OctreeBreadthFirstIterator (OctreeT *octree_arg, unsigned int max_depth_arg, IteratorState *current_state, const std::deque< IteratorState > &fifo=std::deque< IteratorState >())
| Constructor. More...
| OctreeBreadthFirstIterator (const OctreeBreadthFirstIterator &other)
| Copy Constructor. More...
OctreeBreadthFirstIterator & | operator= (const OctreeBreadthFirstIterator &src)
| Copy operator. More...
void | reset ()
| Reset the iterator to the root node of the octree. More...
OctreeBreadthFirstIterator & | operator++ ()
| Preincrement operator. More...
OctreeBreadthFirstIterator | operator++ (int)
| postincrement operator. More...
Public Member Functions inherited from pcl::octree::OctreeIteratorBase< OctreeT >
| OctreeIteratorBase (unsigned int max_depth_arg=0)
| Empty constructor. More...
| OctreeIteratorBase (OctreeT *octree_arg, unsigned int max_depth_arg=0)
| Constructor. More...
| OctreeIteratorBase (OctreeT *octree_arg, unsigned int max_depth_arg, IteratorState *current_state)
| Constructor. More...
virtual | ~OctreeIteratorBase ()
| Empty deconstructor. More...
bool | operator== (const OctreeIteratorBase &other) const
| Equal comparison operator. More...
bool | operator!= (const OctreeIteratorBase &other) const
| Inequal comparison operator. More...
void | reset ()
| Reset iterator. More...
const OctreeKey & | getCurrentOctreeKey () const
| Get octree key for the current iterator octree node. More...
unsigned int | getCurrentOctreeDepth () const
| Get the current depth level of octree. More...
OctreeNode * | getCurrentOctreeNode () const
| Get the current octree node. More...
bool | isBranchNode () const
| check if current node is a branch node More...
bool | isLeafNode () const
| check if current node is a branch node More...
OctreeNode * | operator* () const
| *operator. More...
char | getNodeConfiguration () const
| Get bit pattern of children configuration of current node. More...
const LeafContainer & | getLeafContainer () const
| Method for retrieving a single leaf container from the octree leaf node. More...
LeafContainer & | getLeafContainer ()
| Method for retrieving a single leaf container from the octree leaf node. More...
const BranchContainer & | getBranchContainer () const
| Method for retrieving the container from an octree branch node. More...
BranchContainer & | getBranchContainer ()
| Method for retrieving the container from an octree branch node. More...
virtual unsigned long | getNodeID () const
| get a integer identifier for current node (note: identifier depends on tree depth). More...

## Additional Inherited Members

Public Types inherited from pcl::octree::OctreeBreadthFirstIterator< OctreeT >
using | BranchNode = typename OctreeIteratorBase< OctreeT >::BranchNode
using | LeafNode = typename OctreeIteratorBase< OctreeT >::LeafNode
Public Types inherited from pcl::octree::OctreeIteratorBase< OctreeT >
using | LeafNode = typename OctreeT::LeafNode
using | BranchNode = typename OctreeT::BranchNode
using | LeafContainer = typename OctreeT::LeafContainer
using | BranchContainer = typename OctreeT::BranchContainer
Protected Attributes inherited from pcl::octree::OctreeBreadthFirstIterator< OctreeT >
std::deque< IteratorState > | FIFO_
| FIFO list. More...
Protected Attributes inherited from pcl::octree::OctreeIteratorBase< OctreeT >
OctreeT * | octree_
| Reference to octree class. More...
IteratorState * | current_state_
| Pointer to current iterator state. More...
unsigned int | max_octree_depth_
| Maximum octree depth. More...

## Detailed Description

### template<typename OctreeT>
class pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT >

Octree leaf node iterator class.

Note
  This class implements a forward iterator for traversing the leaf nodes of an octree data structure in the breadth first way.

Author
  Fabien Rozar (fabie.nosp@m.n.ro.nosp@m.zar@g.nosp@m.mail.nosp@m..com)

Definition at line 767 of file octree_iterator.h.

## Constructor & Destructor Documentation

## OctreeLeafNodeBreadthFirstIterator() [1/3]

template<typename OctreeT >

pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT >::OctreeLeafNodeBreadthFirstIterator | ( | unsigned int | max_depth_arg = `0` | ) |

explicit

Empty constructor.

Parameters

  [in] | max_depth_arg | Depth limitation during traversal

Definition at line 325 of file octree_iterator.hpp.

References pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT >::reset().

## OctreeLeafNodeBreadthFirstIterator() [2/3]

template<typename OctreeT >

pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT >::OctreeLeafNodeBreadthFirstIterator | ( | OctreeT * | octree_arg,
|  | unsigned int | max_depth_arg = `0`
| ) |  |

explicit

Constructor.

Parameters

  [in] | octree_arg | Octree to be iterated. Initially the iterator is set to its root node.
  [in] | max_depth_arg | Depth limitation during traversal

Definition at line 333 of file octree_iterator.hpp.

References pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT >::reset().

## OctreeLeafNodeBreadthFirstIterator() [3/3]

template<typename OctreeT >

pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT >::OctreeLeafNodeBreadthFirstIterator | ( | OctreeT * | octree_arg,
|  | unsigned int | max_depth_arg,
|  | IteratorState * | current_state,
|  | const std::deque< IteratorState > & | fifo = `std::deque<IteratorState> ()`
| ) |  |

explicit

Copy constructor.

Parameters

  [in] | octree_arg | Octree to be iterated. Initially the iterator is set to its root node.
  [in] | max_depth_arg | Depth limitation during traversal
  [in] | current_state | A pointer to the current iterator state
  [in] | fifo | Internal container of octree node to go through

Warning
  For advanced users only.

Definition at line 341 of file octree_iterator.hpp.

## Member Function Documentation

## operator++() [1/2]

template<typename OctreeT >

OctreeLeafNodeBreadthFirstIterator< OctreeT > & pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT >::operator++ | ( |  | ) |

inline

Preincrement operator.

Note
  recursively step to next octree leaf node

Definition at line 362 of file octree_iterator.hpp.

References pcl::octree::LEAF_NODE, and pcl::octree::OctreeBreadthFirstIterator< OctreeT >::operator++().

## operator++() [2/2]

template<typename OctreeT >

OctreeLeafNodeBreadthFirstIterator< OctreeT > pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT >::operator++ | ( | int |  | ) |

inline

Postincrement operator.

Note
  step to next octree node

Definition at line 375 of file octree_iterator.hpp.

## reset()

template<typename OctreeT >

void pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT >::reset | ( |  | ) |

inline

Reset the iterator to the first leaf in the breadth first way.

Definition at line 353 of file octree_iterator.hpp.

References pcl::octree::OctreeBreadthFirstIterator< OctreeT >::reset().

Referenced by pcl::octree::OctreeLeafNodeBreadthFirstIterator< OctreeT >::OctreeLeafNodeBreadthFirstIterator().

The documentation for this class was generated from the following files:

- pcl/octree/octree_iterator.h
- pcl/octree/impl/octree_iterator.hpp